/****************************************************************************************** 
 *	Chili DirectX Framework Version 16.07.20											  *	
 *	Game.cpp																			  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "MainWindow.h"
#include "Game.h"

Game::Game( MainWindow& wnd )
	:
	wnd( wnd ),
	gfx( wnd )
{
}

void Game::Go()
{
	gfx.BeginFrame();	
	UpdateModel();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::UpdateModel()
{
	if (wnd.kbd.KeyIsPressed(VK_RIGHT))
	{
		linkX += 2;
	}
	if (wnd.kbd.KeyIsPressed(VK_LEFT))
	{
		linkX -= 2;
	}
	if (wnd.kbd.KeyIsPressed(VK_DOWN))
	{
		linkY += 2;
	}
	if (wnd.kbd.KeyIsPressed(VK_UP))
	{
		linkY -= 2;
	}

	linkX = ClampScreenX( linkX,linkWidth );
	linkY = ClampScreenY( linkY,linkHeight );

	if (IsColliding(linkX, linkY, linkWidth, linkHeight, 
		rupee0X, rupee0Y, rupeeWidth, rupeeHeight))
	{
		rupee0IsGot = true;
	}
	if (IsColliding(linkX, linkY, linkWidth, linkHeight,
		rupee1X, rupee1Y, rupeeWidth, rupeeHeight))
	{
		rupee1IsGot = true;
	}
	if (IsColliding(linkX, linkY, linkWidth, linkHeight,
		rupee2X, rupee2Y, rupeeWidth, rupeeHeight))
	{
		rupee2IsGot = true;
	}

}

void Game::DrawLink(int x, int y)
{
	gfx.PutPixel(5 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(6 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(7 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(8 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(9 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(10 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(11 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(12 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 0 + y, 181, 255, 90);
	gfx.PutPixel(4 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(5 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(6 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(7 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(8 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(9 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(10 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(11 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(12 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 1 + y, 181, 255, 90);
	gfx.PutPixel(1 + x, 2 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 2 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 2 + y, 181, 255, 90);
	gfx.PutPixel(5 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(9 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(14 + x, 2 + y, 239, 123, 24);
	gfx.PutPixel(15 + x, 2 + y, 181, 255, 90);
	gfx.PutPixel(17 + x, 2 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 2 + y, 255, 173, 90);
	gfx.PutPixel(1 + x, 3 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 3 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 3 + y, 181, 255, 90);
	gfx.PutPixel(5 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(9 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(14 + x, 3 + y, 239, 123, 24);
	gfx.PutPixel(15 + x, 3 + y, 181, 255, 90);
	gfx.PutPixel(17 + x, 3 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 3 + y, 255, 173, 90);
	gfx.PutPixel(1 + x, 4 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 4 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(9 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(14 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(15 + x, 4 + y, 239, 123, 24);
	gfx.PutPixel(17 + x, 4 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 4 + y, 255, 173, 90);
	gfx.PutPixel(1 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 5 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(6 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(7 + x, 5 + y, 181, 255, 90);
	gfx.PutPixel(8 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(10 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(11 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(12 + x, 5 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(14 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(15 + x, 5 + y, 239, 123, 24);
	gfx.PutPixel(16 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 5 + y, 255, 173, 90);
	gfx.PutPixel(1 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 6 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(6 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(7 + x, 6 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(10 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(11 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(12 + x, 6 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(14 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(15 + x, 6 + y, 239, 123, 24);
	gfx.PutPixel(16 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 6 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(5 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(6 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(7 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(8 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(10 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(11 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(12 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(13 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(14 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(15 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(16 + x, 7 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 7 + y, 239, 123, 24);
	gfx.PutPixel(18 + x, 7 + y, 239, 123, 24);
	gfx.PutPixel(3 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(5 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(6 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(7 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(8 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(10 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(11 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(12 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(13 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(14 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(15 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(16 + x, 8 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 8 + y, 239, 123, 24);
	gfx.PutPixel(18 + x, 8 + y, 239, 123, 24);
	gfx.PutPixel(4 + x, 9 + y, 181, 255, 90);
	gfx.PutPixel(5 + x, 9 + y, 181, 255, 90);
	gfx.PutPixel(6 + x, 9 + y, 181, 255, 90);
	gfx.PutPixel(7 + x, 9 + y, 255, 173, 90);
	gfx.PutPixel(8 + x, 9 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 9 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 9 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 9 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 9 + y, 255, 173, 90);
	gfx.PutPixel(13 + x, 9 + y, 255, 173, 90);
	gfx.PutPixel(14 + x, 9 + y, 255, 173, 90);
	gfx.PutPixel(15 + x, 9 + y, 181, 255, 90);
	gfx.PutPixel(16 + x, 9 + y, 181, 255, 90);
	gfx.PutPixel(17 + x, 9 + y, 239, 123, 24);
	gfx.PutPixel(18 + x, 9 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(2 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(3 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(4 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 10 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 10 + y, 255, 173, 90);
	gfx.PutPixel(10 + x, 10 + y, 255, 173, 90);
	gfx.PutPixel(11 + x, 10 + y, 255, 173, 90);
	gfx.PutPixel(12 + x, 10 + y, 255, 173, 90);
	gfx.PutPixel(13 + x, 10 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 10 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 10 + y, 181, 255, 90);
	gfx.PutPixel(16 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(17 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(18 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(19 + x, 10 + y, 239, 123, 24);
	gfx.PutPixel(0 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(2 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(3 + x, 11 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(9 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(10 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(11 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(12 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 11 + y, 181, 255, 90);
	gfx.PutPixel(16 + x, 11 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(18 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(19 + x, 11 + y, 239, 123, 24);
	gfx.PutPixel(0 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(5 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 12 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 12 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 12 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(16 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 12 + y, 255, 173, 90);
	gfx.PutPixel(19 + x, 12 + y, 239, 123, 24);
	gfx.PutPixel(0 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(5 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 13 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 13 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 13 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(16 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 13 + y, 255, 173, 90);
	gfx.PutPixel(19 + x, 13 + y, 239, 123, 24);
	gfx.PutPixel(0 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(2 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(3 + x, 14 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 14 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 14 + y, 181, 255, 90);
	gfx.PutPixel(10 + x, 14 + y, 181, 255, 90);
	gfx.PutPixel(11 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(14 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(15 + x, 14 + y, 239, 123, 24);
	gfx.PutPixel(16 + x, 14 + y, 255, 173, 90);
	gfx.PutPixel(17 + x, 14 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 14 + y, 255, 173, 90);
	gfx.PutPixel(19 + x, 14 + y, 255, 173, 90);
	gfx.PutPixel(0 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(2 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(3 + x, 15 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 15 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(10 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(11 + x, 15 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 15 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 15 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 15 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 15 + y, 181, 255, 90);
	gfx.PutPixel(16 + x, 15 + y, 181, 255, 90);
	gfx.PutPixel(17 + x, 15 + y, 255, 173, 90);
	gfx.PutPixel(18 + x, 15 + y, 255, 173, 90);
	gfx.PutPixel(0 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(2 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(3 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(4 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 16 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 16 + y, 255, 173, 90);
	gfx.PutPixel(9 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(10 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(11 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(12 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(13 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(14 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(15 + x, 16 + y, 181, 255, 90);
	gfx.PutPixel(1 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(5 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(6 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(7 + x, 17 + y, 255, 173, 90);
	gfx.PutPixel(8 + x, 17 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 17 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 17 + y, 239, 123, 24);
	gfx.PutPixel(14 + x, 17 + y, 239, 123, 24);
	gfx.PutPixel(15 + x, 17 + y, 239, 123, 24);
	gfx.PutPixel(1 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(2 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(3 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(4 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(5 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(6 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(7 + x, 18 + y, 255, 173, 90);
	gfx.PutPixel(8 + x, 18 + y, 239, 123, 24);
	gfx.PutPixel(12 + x, 18 + y, 239, 123, 24);
	gfx.PutPixel(13 + x, 18 + y, 239, 123, 24);
	gfx.PutPixel(14 + x, 18 + y, 239, 123, 24);
	gfx.PutPixel(15 + x, 18 + y, 239, 123, 24);
	gfx.PutPixel(5 + x, 19 + y, 239, 123, 24);
	gfx.PutPixel(6 + x, 19 + y, 239, 123, 24);
	gfx.PutPixel(7 + x, 19 + y, 239, 123, 24);
	gfx.PutPixel(8 + x, 19 + y, 239, 123, 24);

}

void Game::DrawRupee(int x, int y)
{
	gfx.PutPixel(3 + x, 0 + y, 255, 255, 255);
	gfx.PutPixel(4 + x, 0 + y, 255, 255, 255);
	gfx.PutPixel(5 + x, 0 + y, 0, 132, 255);
	gfx.PutPixel(2 + x, 1 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 1 + y, 255, 255, 255);
	gfx.PutPixel(4 + x, 1 + y, 255, 255, 255);
	gfx.PutPixel(5 + x, 1 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 1 + y, 0, 132, 255);
	gfx.PutPixel(1 + x, 2 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 2 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 2 + y, 255, 255, 255);
	gfx.PutPixel(4 + x, 2 + y, 255, 255, 255);
	gfx.PutPixel(5 + x, 2 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 2 + y, 0, 132, 255);
	gfx.PutPixel(7 + x, 2 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 3 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 3 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 3 + y, 0, 132, 255);
	gfx.PutPixel(3 + x, 3 + y, 255, 255, 255);
	gfx.PutPixel(4 + x, 3 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 3 + y, 0, 0, 0);
	gfx.PutPixel(6 + x, 3 + y, 0, 132, 255);
	gfx.PutPixel(7 + x, 3 + y, 0, 0, 0);
	gfx.PutPixel(8 + x, 3 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 4 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 4 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 4 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 4 + y, 0, 132, 255);
	gfx.PutPixel(4 + x, 4 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 4 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 4 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 4 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 4 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 5 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 5 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 5 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 5 + y, 0, 132, 255);
	gfx.PutPixel(4 + x, 5 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 5 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 5 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 5 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 5 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 6 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 6 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 6 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 6 + y, 0, 132, 255);
	gfx.PutPixel(4 + x, 6 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 6 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 6 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 6 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 6 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 7 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 7 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 7 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 7 + y, 0, 132, 255);
	gfx.PutPixel(4 + x, 7 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 7 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 7 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 7 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 7 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 8 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 8 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 8 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 8 + y, 0, 132, 255);
	gfx.PutPixel(4 + x, 8 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 8 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 8 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 8 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 8 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 9 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 9 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 9 + y, 255, 255, 255);
	gfx.PutPixel(3 + x, 9 + y, 0, 132, 255);
	gfx.PutPixel(4 + x, 9 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 9 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 9 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 9 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 9 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 10 + y, 255, 255, 255);
	gfx.PutPixel(1 + x, 10 + y, 255, 255, 255);
	gfx.PutPixel(2 + x, 10 + y, 0, 123, 255);
	gfx.PutPixel(3 + x, 10 + y, 0, 0, 0);
	gfx.PutPixel(4 + x, 10 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 10 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 10 + y, 0, 0, 0);
	gfx.PutPixel(7 + x, 10 + y, 0, 132, 255);
	gfx.PutPixel(8 + x, 10 + y, 0, 132, 255);
	gfx.PutPixel(0 + x, 11 + y, 0, 123, 255);
	gfx.PutPixel(1 + x, 11 + y, 0, 123, 255);
	gfx.PutPixel(2 + x, 11 + y, 0, 123, 255);
	gfx.PutPixel(3 + x, 11 + y, 0, 123, 255);
	gfx.PutPixel(4 + x, 11 + y, 0, 0, 0);
	gfx.PutPixel(5 + x, 11 + y, 0, 0, 0);
	gfx.PutPixel(6 + x, 11 + y, 0, 132, 255);
	gfx.PutPixel(7 + x, 11 + y, 0, 0, 0);
	gfx.PutPixel(8 + x, 11 + y, 0, 132, 255);
	gfx.PutPixel(1 + x, 12 + y, 0, 123, 255);
	gfx.PutPixel(2 + x, 12 + y, 0, 123, 255);
	gfx.PutPixel(3 + x, 12 + y, 0, 123, 255);
	gfx.PutPixel(4 + x, 12 + y, 0, 123, 255);
	gfx.PutPixel(5 + x, 12 + y, 0, 123, 255);
	gfx.PutPixel(6 + x, 12 + y, 0, 132, 255);
	gfx.PutPixel(7 + x, 12 + y, 0, 132, 255);
	gfx.PutPixel(2 + x, 13 + y, 0, 123, 255);
	gfx.PutPixel(3 + x, 13 + y, 0, 123, 255);
	gfx.PutPixel(4 + x, 13 + y, 0, 123, 255);
	gfx.PutPixel(5 + x, 13 + y, 0, 132, 255);
	gfx.PutPixel(6 + x, 13 + y, 0, 132, 255);
	gfx.PutPixel(3 + x, 14 + y, 0, 123, 255);
	gfx.PutPixel(4 + x, 14 + y, 0, 132, 255);
	gfx.PutPixel(5 + x, 14 + y, 0, 132, 255);


}

int Game::ClampScreenX(int x, int width)
{
	const int right = x + width;
	if (x <0)
	{
		return 0;
	}
	else if (right >= gfx.ScreenWidth) {
		return (gfx.ScreenWidth - 1) - width;
	}
	else
	{
		return x;
	}
	
}

int Game::ClampScreenY(int y, int height)
{
	const int right = y + height;
	if (y <0)
	{
		return 0;
	}
	else if (right >= gfx.ScreenHeight) {
		return (gfx.ScreenHeight - 1) - height;
	}
	else
	{
		return y;
	}
}

bool Game::IsColliding(int x0, int y0, int width0, int height0,
	int x1, int y1, int width1, int height1)
{
	
	const int right0 = x0 + width0;
	const int bottom0 = y0 = height0;
	const int right1 = x1 + width1;
	const int bottom1 = y1 + height1;
	return
		right0 >= x1 &&
		x0 <= right1 &&
		bottom0 >= y1 &&
		y0 <= bottom1;
		
}

void Game::ComposeFrame()
{
	DrawLink(linkX, linkY);
	if (!rupee0IsGot)
	{
		DrawRupee(rupee0X, rupee0Y);
	}
	if (!rupee1IsGot)
	{
		DrawRupee(rupee1X, rupee1Y);
	}
	if (!rupee2IsGot) 
	{
		DrawRupee( rupee2X, rupee2Y );
	}
}
